#include <X11/Xlib.h>

#include <stdio.h>
//#include <string.h>
/* needed for getenv */
#include <stdlib.h>
#include <X11/X.h>
#include <X11/Xutil.h>
#include <gdk/gdkx.h>
#include <gdk-pixbuf/gdk-pixbuf.h>


GdkPixbuf *im , *im2 ;

GdkPixmap *pixmap,*mask;



static int gdk_pixbuf_png_image_save(FILE * f, GdkPixbuf * pixbuf);



int main(int argc, char **argv) {

    gdk_init(&argc,&argv);
    gdk_rgb_init();

 char *thefile;
 char *backfile;
 char *outfile;
 char *theheight = "20";
 char *thewidth = "20";
 char *theheight2 = "20";
 char *thewidth2 = "20";
 char * offsetx=0;
 char * offsety=0;

        if ( argc == 1 ){
          return 1;
        }
 

  thefile = argv[2];
  backfile = argv[1];
  outfile = argv[3];
  thewidth = argv[4];
  theheight = argv[5];
  thewidth2 = argv[6];
  theheight2 = argv[7];
  offsetx =  argv[8];
  offsety =  argv[9];

  int theight = atoi(theheight);
  int twidth = atoi(thewidth);
  int theight2 = atoi(theheight2);
  int twidth2 = atoi(thewidth2);
  int offx = atoi(offsetx);
  int offy = atoi(offsety);


char roxpic[1024];
sprintf(roxpic , "%s" , outfile);

// printf("option: %s\n" ,option);
 

	FILE *jpgFile;

        char jpgname[1024];

	sprintf(jpgname,roxpic);

gint zoom_quality = (gint)GDK_INTERP_HYPER;

im = gdk_pixbuf_new_from_file ( backfile , NULL);
im2 = gdk_pixbuf_new_from_file ( thefile , NULL);


int  w=gdk_pixbuf_get_width(im);
int  h=gdk_pixbuf_get_height(im);
if(twidth==0){
	twidth=w;
}
if(theight==0){
	theight=h;
}

if ((w != twidth) ||(h != theight)){
    printf("scaling background\n");
    im = gdk_pixbuf_scale_simple(im,  twidth ,theight, (GdkInterpType)zoom_quality);
    //twidth=w;
    //theight=h;
}

w=gdk_pixbuf_get_width(im2);
h=gdk_pixbuf_get_height(im2);
if(twidth2==0){
	twidth2=w;
}
if(theight2==0){
	theight2=h;
}

if ((w != twidth2) ||(h != theight2)){
    printf("scaling pic\n");
    im2 = gdk_pixbuf_scale_simple(im2,  twidth2 ,theight2, (GdkInterpType)zoom_quality);
    //twidth2=w;
    //theight2=h;
}

//w=gdk_pixbuf_get_width(im2);
//h=gdk_pixbuf_get_height(im2);
//printf("--> %d %d\n" , w , h);

int px=0;
int py=0;

if (offx != 0){
  px = offx;
}
if (offy != 0){
  py = offy;
}

//im=gdk_pixbuf_add_alpha(im,1,255,0,255);

gdk_rgb_get_colormap ();
gdk_pixbuf_render_pixmap_and_mask(im, &pixmap, &mask, 128);
gdk_rgb_get_colormap ();
gdk_draw_pixbuf(pixmap, NULL,im2 ,0,0,px,py,twidth2, theight2,GDK_RGB_DITHER_NONE,0,0);


//printf("--> %d \n" , twidth);

gdk_flush();

gdk_pixbuf_get_from_drawable (im,pixmap,gdk_colormap_get_system() ,0,0,0,0,twidth,theight);



gdk_pixbuf_save ( im , jpgname , "png" ,NULL, NULL);


g_object_unref(im);
//gdk_pixbuf_unref(im2);

  return 0;

}

